Language    = Component

Scanner = {
	"Digit Token"
		digit -> "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"
			;
	"Integer Token"
		INTEGER -> digit moreDigits
			;
	"Float Token"
		FLOAT -> INTEGER "." INTEGER
			;
	"Zero or more digits token"
		moreDigits -> digit moreDigits
			|
			;
	"Characacter Token"
		char -> "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" | "j" | "k" | "l" | "m" | "n" | "" |
			  "o" | "p" | "q" | "r" | "s" | "t" | "u" | "v" | "w" | "x" | "y" | "z" | "" | "" | "" | "" | "" |
			  "A" | "B" | "C" | "D" | "E" | "F" | "G" | "H" | "I" | "J" | "K" | "L" | "M" | "N" | "" |
			  "O" | "P" | "Q" | "R" | "S" | "T" | "U" | "V" | "W" | "X" | "Y" | "Z" | "" | "" | "" | "" | "" 
			;
	"Character or Digit Token"
		charOrDigit -> char
				| digit
				| "_"
				;
	"Row Char Token"
		rowChar -> char
			| digit
			| " " | "," | "." | ":" | ";" | "" | "!" | "" | "?" | "#" | "*" | "/" | "$" | "%" | "&" 
			| "|" | "(" | ")" | "@" | "=" | "[" | "]" | "{" | "}" | "+" | "-" | ">" | "<"
			| "\t" | "\n" | "\\"
			;

	"ID Token"
		ID -> char moreCharsOrDigits
			;
	"Label Token"
		LABEL -> "#" char moreCharsOrDigits "#"
			;
	"String Token"
		STRING -> "'" rowChar moreRowChars "'"
		    ;
	"Zero or more chars or digits token"
		moreCharsOrDigits -> charOrDigit moreCharsOrDigits
			|
			;
	"Zero or more row chars"
		moreRowChars -> rowChar moreRowChars
			|
			;
	"SEMICOLON Token"
		SEMICOLON -> ";"
			;
	"COMMA Token"
		COMMA -> ","
			;
	"OPENCURLYBRACE Token"
		OPENCURLYBRACE -> "{"
			;
	"CLOSECURLYBRACE Token"
		CLOSECURLYBRACE -> "}"
			;
	"OPENBRACE Token"
		OPENBRACE -> "("
			;
	"CLOSEBRACE Token"
		CLOSEBRACE -> ")"
			;
	"PLUS Operator token"
		PLUS -> "+"
			;
	"MINUS Operator token"
		MINUS -> "-"
			;
	"TIMES Operator token"
		TIMES -> "*"
			;
	"BY Operator token"
		BY -> "/"
			;
	"LOWER Operator token"
		LOWER -> "<"
			;
	"LOWEREQUAL Operator token"
		LOWEREQUAL -> "<="
			;
	"GREATER Operator token"
		GREATER -> ">"
			;
	"GREATEREQUAL Operator token"
		GREATEREQUAL -> ">="
			;
	"EQUAL Operator token"
		EQUAL -> "=="
			;
	"NOTEQUAL Operator token"
		NOTEQUAL -> "!="
			;
	"ASIGN token"
		ASIGN -> "="
			;
	"COMPONENT keyword"
		COMPONENT -> "component"
			;
	"NAME keyword"
		NAME -> "name"
			;
	"PROCESS keyword"
		PROCESS -> "process"
			;
	"ACTION keyword"
		ACTION -> "action"
			;
	"CODE keyword"
		CODE -> "code"
			;
	"LOOP keyword"
		LOOP -> "loop"
			;
	"RANDOM keyword"
		RANDOM -> "random"
			;
	"SHOW keyword"
		SHOW -> "show"
			;
	"SHOW LINE keyword"
		SHOWLN -> "showln"
			;
	"SLEEP keyword"
		SLEEP -> "sleep"
			;
	"RETURN keyword"
		RETURN -> "return"
			;
	"CALL keyword"
		CALL -> "call"
			;
	"ASK keyword"
		ASK -> "ask"
			;
	"JUMP keyword"
		JUMP -> "jump"
			;
}


Parser = {
	"Initial Free-Context Rule"
		S -> component moreComponents <#

# Global function used to initialise the component attributes
global initComponent
def initComponent(component,write,name):
	"Component initialisation"
	component.actions={}
	component.loop={}
	component.instructionOrder=[]
	component.ip=0
	component.name=name
	component.componentContext={"write":write}
	exec('from random import randrange\n',component.componentContext)
	exec('from time import sleep\n',component.componentContext)

global noQuotation
def noQuotation(value):
	"Quotation marks deletion"
	if (value[0]=="\"" and value[-1]=="\"")or(value[0]=="\'" and value[-1]=="\'"):
		return value[1:-1]
	else:
		return value
	
nodes[1].execute()
nodes[2].execute()
#>
			;

	"Zero or more component specifications"
		moreComponents -> component moreComponents <#
nodes[1].execute()
nodes[2].execute()
#>
			|
			;

	"Component Declaration" 
		component -> COMPONENT ASIGN OPENCURLYBRACE componentSpec CLOSECURLYBRACE <#
nodes[4].execute()
#>
			;

	"Component Specification"
		componentSpec ->	NAME ASIGN STRING
					PROCESS ASIGN STRING
					actions
					LOOP ASIGN OPENCURLYBRACE loopStatements CLOSECURLYBRACE <#
nodes[3].text=noQuotation(nodes[3].text)
nodes[6].text=noQuotation(nodes[6].text)
# Look for the Control Process Application
if nitrO.apps.has_key(nodes[6].text):
	# Global component object creation
	global component
	component=nitrO.apps[nodes[6].text].applicationGlobalContext["classes"]["Component"]()
	initComponent(component,write,nodes[3].text)
	# Global label counter
	global labelCounter
	labelCounter=0
	# Action and Loop creation
	nodes[7].execute()
	nodes[11].execute()
	# Inserts the component into the control process application, to be recognised and executed
	nitrO.apps[nodes[6].text].applicationGlobalContext['components'][nodes[3].text]=component
else:
	write("The control process application named \""+nodes[6].text+"\" must be started.\n")
#>
			;

	"Actions Declaration"
		actions -> action moreActions <#
nodes[1].execute()
nodes[2].execute()
#>
			;

	"Zero or more action declarations"
		moreActions -> action moreActions <#
nodes[1].execute()
nodes[2].execute()
#>
			|
			;

	"Action Declaration"
		action -> ACTION ASIGN OPENCURLYBRACE actionSpec CLOSECURLYBRACE <#
nodes[4].execute()
#>
			;

	"Action Specficication"
		actionSpec -> NAME ASIGN STRING CODE ASIGN OPENCURLYBRACE actionStatements CLOSECURLYBRACE <#
# Global actionCode that is being created
global actionCode
actionCode=""
nodes[7].execute()
component.actions[noQuotation(nodes[3].text)]=actionCode
#>
			;

	"One or more action statements"
		actionStatements -> actionStatement moreActionStatements SEMICOLON <#
nodes[1].execute()
nodes[2].execute()
#>
			;

	"Zero or more action statements"
		moreActionStatements -> SEMICOLON actionStatement moreActionStatements <#
nodes[2].execute()
nodes[3].execute()
#>
			|
			;

	"One or more loop statements"
		loopStatements -> label loopStatement moreLoopStatements SEMICOLON <#
nodes[1].execute()
nodes[2].execute()
nodes[3].execute()
#>
			;

	"Zero or more loop statements"
		moreLoopStatements -> SEMICOLON label loopStatement moreLoopStatements <#
nodes[2].execute()
nodes[3].execute()
nodes[4].execute()
#>
			|
			;

	"Action Statement"
		actionStatement -> asignment <#
nodes[1].execute()
#>
			| SHOW OPENBRACE printableExpression CLOSEBRACE <#
nodes[3].execute()
global actionCode
actionCode=actionCode+"write("+nodes[3].value+")\n"
#>
			| SHOWLN OPENBRACE printableExpression CLOSEBRACE <#
nodes[3].execute()
global actionCode
actionCode=actionCode+"write("+nodes[3].value+"+\"\\n\")\n"
#>
			| RETURN OPENBRACE expression CLOSEBRACE <#
nodes[3].execute()
global actionCode
actionCode=actionCode+"_result="+nodes[3].value+"\n"
#>
			| SLEEP OPENBRACE expression CLOSEBRACE <#
nodes[3].execute()
global actionCode
actionCode=actionCode+"sleep("+nodes[3].value+"/1000.0)\n"
#>
			;

	"Optional Label"
		label -> LABEL <#
# Global loop statement label
global loopLabel
loopLabel=nodes[1].text
#>
			| <#
# Global loop statement label
global loopLabel,labelCounter
loopLabel=str(labelCounter)
labelCounter=labelCounter+1
#>
			;

	"Loop Statement"
		loopStatement ->  CALL OPENBRACE ID CLOSEBRACE <#
global loopLabel,component
component.loop[loopLabel]=nodes[3].text
component.instructionOrder.append(loopLabel)
#>
			| ASK OPENBRACE ID COMMA LABEL COMMA LABEL CLOSEBRACE <#
global loopLabel,component
component.loop[loopLabel]=[nodes[3].text,nodes[5].text,nodes[7].text]
component.instructionOrder.append(loopLabel)
#>
			| JUMP OPENBRACE LABEL CLOSEBRACE <#
global loopLabel,component
component.loop[loopLabel]=nodes[3].text
component.instructionOrder.append(loopLabel)
#>
			;

	"Asignment Statement"
		asignment -> ID ASIGN expression <#
nodes[3].execute()
global actionCode
actionCode=actionCode+nodes[1].text+"="+nodes[3].value+"\n"
#>
			;

	"Printable Expresion (show statement)"
		printableExpression -> expression <#
nodes[1].execute()
nodes[0].value="str("+nodes[1].value+")"
#>
			| STRING <#
nodes[0].value=nodes[1].text
#>
			;

	"Binary Expression"
		expression -> term moreTerms <#
# Every node has its string representation on the attribute "value"
# Its initival value is saved on the attribute "init"
nodes[1].execute()
nodes[2].init=nodes[1].value
nodes[2].execute()
nodes[0].value=nodes[2].value
#>
			;

	"Zero or More Terms"
		moreTerms -> PLUS term moreTerms <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"+"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| MINUS term moreTerms  <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"-"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| <#
nodes[0].value=nodes[0].init
#>
			;

	"Binary Expression Term"
		term -> factor moreFactors <#
nodes[1].execute()
nodes[2].init=nodes[1].value
nodes[2].execute()
nodes[0].value=nodes[2].value
#>
			;

	"Zero or More Factors"
		moreFactors -> TIMES factor moreFactors <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"*"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| BY factor moreFactors <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"/"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| <#
nodes[0].value=nodes[0].init
#>
			;

	"Binary Expression Factor"
		factor -> comp moreComps <#
nodes[1].execute()
nodes[2].init=nodes[1].value
nodes[2].execute()
nodes[0].value=nodes[2].value
#>
			;

	"Zero or More Comparisons"
		moreComps -> LOWER comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"<"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| LOWEREQUAL comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"<="+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| GREATER comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+">"+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| GREATEREQUAL comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+">="+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| EQUAL comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"=="+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| NOTEQUAL comp moreComps <#
nodes[2].execute()
nodes[3].init=nodes[0].init+"!="+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| <#
nodes[0].value=nodes[0].init
#>
			;

	"Binary Expression Comparison"
		comp -> RANDOM OPENBRACE expression COMMA expression CLOSEBRACE <#
nodes[3].execute()
nodes[5].execute()
nodes[0].value="randrange("+nodes[3].value+",("+nodes[5].value+")+1)"
#>
			| ID <#
nodes[0].value=nodes[1].text
#>
			| FLOAT <#
nodes[0].value=nodes[1].text
#>
			| INTEGER <#
nodes[0].value=nodes[1].text
#>
			| OPENBRACE expression CLOSEBRACE <#
nodes[2].execute()
nodes[0].value="("+nodes[2].value+")"
#>
			| MINUS expression <#
nodes[2].execute()
nodes[0].value="-"+nodes[2].value
#>
			;
}


Skip={  "\t";  "\n";  " "; }
NotSkip = {  }
