Language = Java

Scanner = {
	"Dgito"
	digit -> "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" ;

	"Carcter vlido para un identificador"
	char ->
		  "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i"
		| "j" | "k" | "l" | "m" | "n" | "o" | "p" | "q" | "r"
		| "s" | "t" | "u" | "v" | "w" | "x" | "y" | "z"
		| "A" | "B" | "C" | "D" | "E" | "F" | "G" | "H" | "I"
		| "J" | "K" | "L" | "M" | "N" | "O" | "P" | "Q" | "R"
		| "S" | "T" | "U" | "V" | "W" | "X" | "Y" | "Z"
		| "_"
		;

	"Carcter o dgito"
	charOrDigit -> char | digit ;

	"Cero o ms caracteres o dgitos"
	moreCharsOrDigits -> charOrDigit moreCharsOrDigits | ;

	"Cero o ms dgitos"
	moreDigits -> digit moreDigits | ;

	"Identificador"
	IDENT -> char moreCharsOrDigits ;

	"Entero"
	INTEGER -> digit moreDigits ;

	"Carcter vlido para las cadenas de texto"
	stringChar ->
		  char
		| digit
		| "" | ""
		| "" | "" | "" | "" | ""
		| "" | "" | "" | "" | ""
		| "." | "," | ":" | ";" | "=" | "#" | "$" | "%" | "&" | "|"
		| "(" | ")" | "{" | "}" | "[" | "]" | "+" | "-" | "*" | "/"
		| "<" | ">" | "" | "!" | "" | "?" | "@" | "_" | " "
		;

	"Secuencia de caracteres de una cadena"
	stringChars -> stringChar stringChars | ;

	"Cadena"
	STRING -> "'" stringChars "'" ;

	"Punto y coma"
	SEMI -> ";" ;

	"Parntesis izquierdo"
	LPAREN -> "(" ;

	"Parntesis derecho"
	RPAREN -> ")" ;

	"Llave izquierda"
	LCURLY -> "{" ;

	"Llave derecha"
	RCURLY -> "}" ;

	"Ms"
	PLUS -> "+" ;

	"Menos"
	MINUS -> "-" ;

	"Por"
	MUL -> "*" ;

	"Entre"
	DIV -> "/" ;

	"Mdulo"
	MOD -> "%" ;

	"Asignacin"
	ASSIGN -> "=" ;

	"Igualdad"
	EQUAL -> "==" ;

	"Desigualdad"
	NOTEQUAL -> "!=" ;

	"Identidad"
	IS -> "is" ;

	"Menor"
	LT -> "<" ;

	"Menor o igual"
	LTE -> "<=" ;

	"Mayor"
	GT -> ">" ;

	"Mayor o igual"
	GTE -> ">=" ;

	"Y lgico"
	LAND -> "&&" ;

	"O lgico"
	LOR -> "||" ;

	"Negacin"
	LNOT -> "!" ;

	"Punto"
	DOT -> "." ;

	"Coma"
	COMMA -> "," ;

	"Interrogante"
	QUESTION -> "?" ;

	"Dos puntos"
	COLON -> ":" ;

	"Incremento"
	INC -> "++" ;

	"Decremento"
	DEC -> "--" ;

	"Palabra clave new"
	NEW -> "new" ;

	"Palabra clave true"
	TRUE -> "true" ;

	"Palabra clave false"
	FALSE -> "false" ;

	"Palabra clave if"
	IF -> "if" ;

	"Palabra clave else"
	ELSE -> "else" ;

	"Palabra clave while"
	WHILE -> "while" ;

	"Palabra clave for"
	FOR -> "for" ;

	"Palabra clave class"
	CLASS -> "class" ;

	"Palabra clave extends"
	EXTENDS -> "extends" ;

	"Palabra clave return"
	RETURN -> "return" ;

	"Palabra clave this"
	THIS -> "this" ;

	"Palabra clave true"
	TRUE -> "true" ;

	"Palabra clave super"
	SUPER -> "super" ;

	"Palabra clave null"
	NULL -> "null" ;

	"Palabra clave void"
	VOID -> "void" ;
}

Parser = {
	"Regla inicial"
	S -> bodyStatements
<## S -> bodyStatements
try:
	# Redirigimos la salida a la ventana

	import sys

	class FalseFile(object):
		def __init__(self, write): self.__write = write
		def write(self, str): self.__write(str)

	sys.stdout = FalseFile(write)
	sys.stderr = sys.stdout

	#---------------------------------------------------------------------

	# Importaciones varias

	import traceback, interpreter
	from objs import *
	from pprint import pprint

	#---------------------------------------------------------------------

	# Funciones para automatizar partes de la generacin de cdigo
	# y evitar el copypaste

	global generate_invokeVirtual

	def generate_invokeVirtual(tree, klass, name, args, argTypes):
		#if not nodes[0].lvalue:
		#	raise 'El operando de la llamada a mtodos' \
		#		+ ' debe ser un lvalue'

		method = klass.getMethod(name, argTypes)

		mangledName = method.getMangledName()
		resultTree = ('invokevirtual', tree, mangledName, args)
		resultType = method.getReturnType()

		return resultTree, resultType

	#---------------------------------------------------------------------

	# Tabla de smbolos especfica para el anlisis semntico

	class SymbolTable(object):
		def __init__(self):
			self.currentClass = None
			self.currentMethod = None
			self.currentBlockVars = {}
			self.vars = {}
			self.blockStack = []
			self.varStack = []
		def classEnter(self, klass):
			self.currentClass = klass
			self.blockEnter()
		def classExit(self):
			self.currentClass = None
			self.blockExit()
		def methodEnter(self, method, args):
			self.currentMethod = method
			self.blockEnter()
			for name, klass in args: self.setVar(name, klass)
		def methodExit(self):
			self.blockExit()
			self.currentMethod = None
		def blockEnter(self):
			self.blockStack.append(self.currentBlockVars)
			self.currentBlockVars = {}
			self.varStack.append(self.vars)
			self.vars = self.vars.copy()
		def blockExit(self):
			self.currentBlockVars = self.blockStack.pop()
			self.vars = self.varStack.pop()
		def setVar(self, name, type):
			if name in self.currentBlockVars:
				raise 'La variable %s ya est definida' \
					+ ' en el bloque actual' % name
			self.currentBlockVars[name] = type
			self.vars[name] = type
		def getVar(self, name):
			if name not in self.vars:
				raise ('La variable %s no est definida' \
					+ ' en el mtodo %s') \
					% (name, self.currentMethod)
			return self.vars[name]
		def getCurrentClass(self): return self.currentClass

	global symbolTable
	symbolTable = SymbolTable()

	global classes
	classes = {} # Mapeado nombre -> clase

	global getClass
	def getClass(name):
		try:
			return classes[name]
		except KeyError, e:
			raise 'La clase %s no est definida' % name

	for i in interpreter.primitiveClasses: classes[i.getName()] = i

	nitrO.shell.write(nodes[0].application.name+'> Preloading classes...')
	nodes[1].classMap = {}
	nodes[1].tree = ()
	nodes[1].execute()

	#---------------------------------------------------------------------

	# Ordenamos las clases de acuerdo a su grafo de dependencias

	nitrO.shell.write(nodes[0].application.name+'> Sorting classes...')

	global classMap
	classMap = nodes[1].classMap
	classList = []
	userClasses = classMap.keys()
	global allClasses # Para que no se queje luego la funcin del filter
	allClasses = classes.keys() # Las de usuario las metemos luego poco a poco
	def classFilterFunc(name):
		parent = classMap[name][1]
		return parent in allClasses
	while userClasses:
		tmp = filter(classFilterFunc, userClasses)
		for c in tmp: userClasses.remove(c)
		allClasses += tmp
		classList += tmp

	#---------------------------------------------------------------------

	# Creamos las clases

	nitrO.shell.write(nodes[0].application.name+'> Creating classes...')
	for c in classList:
		parent = classMap[c][1]
		try:
			parentObj = getClass(parent)
		except KeyError, e:
			raise 'La clase base %s no est definida' % parent
		classes[c] = JClass(c, parentObj)

	#---------------------------------------------------------------------

	# Cogemos los campos y mtodos de cada clase

	nitrO.shell.write(nodes[0].application.name+"> Preloading classes' members...")

	global classFields, classMethods, classConstructors
	classFields = {}
	classMethods = {}
	classConstructors = {}

	for c in classList:
		klass = classMap[c]
		symbolTable.classEnter(classes[c])
		members = klass[2]
		members.fields = {}
		members.methods = []
		members.constructors = []
		members.execute()
		classFields[c] = members.fields
		classMethods[c] = members.methods
		classConstructors[c] = members.constructors

	#---------------------------------------------------------------------

	# Creamos los campos y mtodos de cada clase y se los aadimos

	global currentReturnType
	global parsingConstructors, firstStatement, hasSuperStatement

	global theInterpreter
	theInterpreter = interpreter.Interpreter(nodes[0].application, classes)
	theInterpreter.write = write

	nitrO.shell.write(nodes[0].application.name+"> Creating classes' members...")

	pendingMethods = {}
	pendingConstructors = {}

	for c in classList:
		klass = classes[c]
		symbolTable.classEnter(klass)

		klass.updateFromParent()

		for f in classFields[c].values():
			field = JField(f[0], f[1], theInterpreter.parse(f[2]))
			klass.addField(field)

		pm = pendingMethods[klass] = []
		for m in classMethods[c]:
			name = m[0]
			currentReturnType = classes[m[1]]
			args = [(x[0], classes[x[1]]) for x in m[2]]
			codeNode = m[3]
			method = JMethod(name, currentReturnType, args)
			klass.addMethod(method)
			pm.append((method, currentReturnType, args, codeNode))

		pc = pendingConstructors[klass] = []
		for m in classConstructors[c]:
			name = m[0]
			args = [(x[0], classes[x[1]]) for x in m[1]]
			codeNode = m[2]
			constructor = JConstructor(klass, args)
			klass.addConstructor(constructor)
			pc.append((constructor, args, codeNode))

		# Se aade el constructor por defecto si no tiene ninguno
		klass.addDefaultConstructor()

		symbolTable.classExit()

	for klass in pendingMethods.keys():
		symbolTable.classEnter(klass)

		for f in klass.getFields().values():
			symbolTable.setVar(f.getName(), f.getClass())

		parsingConstructors = False
		for m in pendingMethods[klass]:
			method = m[0]
			currentReturnType = m[1]
			args = m[2]
			codeNode = m[3]

			symbolTable.methodEnter(method, args)
			codeNode.execute()
			symbolTable.methodExit()
			code = UserCodeWrapper(codeNode.tree)
			method.setCode(code)

		parsingConstructors = True
		currentReturnType = interpreter.voidClass
		for c in pendingConstructors[klass]:
			constructor = c[0]
			args = c[1]
			codeNode = c[2]

			symbolTable.methodEnter(constructor, args)
			firstStatement = True
			hasSuperStatement = False
			codeNode.execute()
			symbolTable.methodExit()
			code = UserCodeWrapper(codeNode.tree)
			constructor.setCode(code)
			constructor.setHasSuperStatement(hasSuperStatement)

		symbolTable.classExit()

	#---------------------------------------------------------------------

	# Parseamos el main

	nitrO.shell.write(nodes[0].application.name+'> Preloading main program...')
	main = nodes[1].main
	main.execute()
	tree = main.tree

	#pprint(tree)
	nitrO.shell.write(nodes[0].application.name+'> Running!')
	#print '-' * 79

	#---------------------------------------------------------------------

	# A ejecutar 
	theInterpreter.parse(tree)
	theInterpreter.terminate()

except SystemExit, e:
	print e
except:
	traceback.print_exc()
#>
	;

	"Lo que puede ir en el cuerpo del programa"
	bodyStatements ->
		  classDef bodyStatements
<## bodyStatements -> classDef bodyStatements
nodes[1].classMap = nodes[0].classMap
nodes[1].execute()
nodes[2].classMap = nodes[0].classMap
nodes[2].execute()
nodes[0].main = nodes[2].main
#>
		| main
<## bodyStatements -> main
nodes[0].main = nodes[1]
#>
		;

	"El programa principal (lo que sera el public static void main...)"
	main ->
		  statementBlock
<## main -> statementBlock
nodes[1].execute()
nodes[0].tree = ('main', nodes[1].tree)
#>
		;

	"Una clase"
	classDef ->
		  CLASS IDENT extends LCURLY members RCURLY
<## classDef -> CLASS IDENT extends LCURLY members RCURLY
nodes[3].execute()

name = nodes[2].text
tmpClassMap = nodes[0].classMap
if (name in tmpClassMap) or (name in classes):
	raise 'Ya existe una clase llamada %s' % name
tmpClassMap[name] = (name, nodes[3].parent, nodes[5])
#>
		;

	"La clase padre, de haberla"
	extends ->
		  EXTENDS IDENT
<## extends -> EXTENDS IDENT
nodes[0].parent = nodes[2].text
#>
		|
<## extends ->
nodes[0].parent = 'Object' # En Java, Object es la "superclase csmica"
#>
		;

	"Los miembros"
	members ->
		  IDENT LPAREN args RPAREN statementBlock members
<## members -> IDENT LPAREN args RPAREN statementBlock members
name = nodes[1].text
className = symbolTable.getCurrentClass().getName()
if name != className:
	raise 'El constructor tiene que tener el mismo nombre que la clase (%s)' \
		% className

nodes[3].execute()

constructors = nodes[0].constructors
constructors.append((name, nodes[3].args, nodes[5]))

nodes[6].methods = nodes[0].methods
nodes[6].fields = nodes[0].fields
nodes[6].constructors = constructors
nodes[6].execute()
#>
		| VOID IDENT LPAREN args RPAREN statementBlock members
<## members -> VOID LPAREN args RPAREN statementBlock members
name = nodes[2].text
className = symbolTable.getCurrentClass().getName()
if name == className: raise 'El constructor no puede devolver un valor'

nodes[4].execute()

# Como tipo del mtodo ponemos <void>, una pseudoclase que no derivar de
# Object; de esa forma, podemos hacer todas las comprobaciones de tipos sin
# necesidad de casos especiales (salvo para los nulos)
methods = nodes[0].methods
methods.append((name, '<void>', nodes[4].args, nodes[6]))

nodes[7].methods = methods
nodes[7].fields = nodes[0].fields
nodes[7].constructors = nodes[0].constructors
nodes[7].execute()
#>
		| IDENT IDENT LPAREN args RPAREN statementBlock members
<## members -> IDENT IDENT LPAREN args RPAREN statementBlock members
name = nodes[2].text
className = symbolTable.getCurrentClass().getName()
if name == className: raise 'El constructor no puede devolver un valor'

nodes[4].execute()

methods = nodes[0].methods
methods.append((name, nodes[1].text, nodes[4].args, nodes[6]))

nodes[7].methods = methods
nodes[7].fields = nodes[0].fields
nodes[7].constructors = nodes[0].constructors
nodes[7].execute()
#>
		| IDENT IDENT ASSIGN conditionalExpr moreFieldDecls members
<## members -> IDENT IDENT ASSIGN conditionalExpr moreFieldDecls members
fields = nodes[0].fields
name = nodes[2].text
klass = getClass(nodes[1].text)

if name in fields:
	raise SystemExit('Ya existe un campo llamado %s' % name)

nodes[4].execute()
rtype = nodes[4].type
if not rtype.isA(klass):
	raise 'No se puede asignar un %s a un %s' % (rtype, klass)
fields[name] = (name, klass, nodes[4].tree)

nodes[5].fields = fields
nodes[5].type = klass
nodes[5].execute()

nodes[6].fields = fields
nodes[6].methods = nodes[0].methods
nodes[6].constructors = nodes[0].constructors
nodes[6].execute()
#>
		| IDENT IDENT moreFieldDecls members
<## members -> IDENT IDENT moreFieldDecls members
fields = nodes[0].fields
name = nodes[2].text
klass = getClass(nodes[1].text)

if name in fields:
	raise SystemExit('Ya existe un campo llamado %s' % name)

fields[name] = (name, klass, ('null',))

nodes[3].fields = fields
nodes[3].type = klass
nodes[3].execute()

nodes[4].fields = fields
nodes[4].methods = nodes[0].methods
nodes[4].constructors = nodes[0].constructors
nodes[4].execute()
#>
		|
		;

	"Cero o ms argumentos separados por comas"
	args ->
		  IDENT IDENT moreArgs
<#
nodes[3].args = ((nodes[2].text, nodes[1].text),)
nodes[3].execute()
nodes[0].args = nodes[3].args
#>
		|
<#
nodes[0].args = ()
#>
		;

	"Ms argumentos separados por comas..."
	moreArgs ->
		  COMMA IDENT IDENT moreArgs
<#
args = nodes[0].args
name = nodes[3].text

duplicado = bool(filter(lambda i, name = name: i[0] == name, args))
if duplicado:
	raise SystemExit('Nombre de parmetro duplicado: %s' % name)

nodes[4].args = args + ((name, nodes[2].text),)
nodes[4].execute()
nodes[0].args = nodes[4].args
#>
		|
		;

	"Ms declaraciones de variables"
	moreFieldDecls ->
		  COMMA IDENT ASSIGN conditionalExpr moreFieldDecls
<#
fields = nodes[0].fields
name = nodes[2].text
klass = nodes[0].type

if name in fields:
	raise SystemExit('Ya existe un campo llamado %s' % name)

nodes[4].execute()
rtype = nodes[4].type
if not rtype.isA(klass):
	raise 'No se puede asignar un %s a un %s' % (rtype, klass)
fields[name] = (name, klass, nodes[4].tree)

nodes[5].fields = fields
nodes[5].type = klass
nodes[5].execute()
#>
		| COMMA IDENT moreFieldDecls
<#
fields = nodes[0].fields
name = nodes[2].text
klass = nodes[0].type

if name in fields:
	raise SystemExit('Ya existe un campo llamado %s' % name)

fields[name] = (name, klass, ('null',))

nodes[3].fields = fields
nodes[3].type = klass
nodes[3].execute()
#>
		| SEMI
		;

	"Cero o ms sentencias"
	statements ->
		  statement statements
<## statements -> statement statements
nodes[1].execute()
nodes[2].tree = (nodes[1].tree,)
nodes[2].execute()
nodes[0].tree += nodes[2].tree
#>
		|
		;

	"Una sentencia"
	statement ->
		  statementBlock
<## statement -> statementBlock
global firstStatement # SI NO SE MARCA COMO GLOBAL ASIGNA A UNA VARIABLE LOCAL
firstStatement = False
nodes[1].execute()
nodes[0].tree = nodes[1].tree
#>
		| _REIFY_
<## statement -> _REIFY_
nodes[0].tree = ('reify', nodes[1])
#>
		| IF LPAREN optimizedExpressions RPAREN statement elseBlock
<## statement -> IF LPAREN optimizedExpressions RPAREN statement elseBlock
global firstStatement
firstStatement = False
nodes[3].execute()
nodes[5].execute()
nodes[6].execute()
nodes[0].tree = ('if', nodes[3].tree, nodes[5].tree, nodes[6].tree)
#>
		| WHILE LPAREN optimizedExpressions RPAREN statement
<## statement -> WHILE LPAREN optimizedExpressions RPAREN statement
global firstStatement
firstStatement = False
nodes[3].execute()
nodes[5].execute()
nodes[0].tree = ('while', nodes[3].tree, nodes[5].tree)
#>
		| FOR LPAREN forInit SEMI
			optimizedExpressions SEMI
			optimizedExpressions RPAREN statement
<## statement -> FOR LPAREN forInit SEMI
#	optimizedExpressions SEMI
#	optimizedExpressions RPAREN statement
global firstStatement
firstStatement = False
symbolTable.blockEnter()
nodes[3].execute()
nodes[5].execute()
nodes[7].execute()
nodes[9].execute()
symbolTable.blockExit()

nodes[0].tree = ('for', nodes[3].tree, nodes[5].tree, nodes[7].tree,
	nodes[9].tree)
#>
		| simpleStatement SEMI
<## statements -> simpleStatement SEMI
nodes[1].execute()
nodes[0].tree = nodes[1].tree
global firstStatement
firstStatement = False
#>
		;

	"El else del if"
	elseBlock ->
		  ELSE statement
<## elseBlock -> ELSE statement
nodes[2].execute()
nodes[0].tree = nodes[2].tree
#>
		|
<## elseBlock ->
nodes[0].tree = ()
#>
		;

	"Posibles inicializaciones en el bucle del for"
	forInit ->
		  IDENT IDENT ASSIGN assignExpr moreVarDecls
<## forInit -> IDENT IDENT ASSIGN assignExpr moreVarDecls
klassName = nodes[1].text
klass = getClass(klassName)

nodes[4].execute()
rtype = nodes[4].type
if not rtype.isA(klass):
	raise 'No se puede asignar un %s a un %s' % (rtype, klass)

nodes[5].tree = ((nodes[2].text, nodes[4].tree),)
nodes[5].type = klass
nodes[5].execute()

for (name, init) in nodes[5].tree:
	symbolTable.setVar(name, klass)

nodes[0].tree = ('decl', klass) + nodes[5].tree
#>
		| IDENT IDENT moreVarDecls
<## forInit -> IDENT IDENT moreVarDecls
klassName = nodes[1].text
klass = getClass(klassName)

nodes[3].tree = ((nodes[2].text, ('null',)),)
nodes[3].type = klass
nodes[3].execute()

for (name, init) in nodes[3].tree:
	symbolTable.setVar(name, klass)

nodes[0].tree = ('decl', klass) + nodes[3].tree
#>
		| optimizedExpressions
<## forInit -> optimizedExpressions
nodes[1].execute()
nodes[0].tree = nodes[1].tree
#>
		|
<## forInit ->
nodes[0].tree = ()
#>
		;

	"Bloque de sentencias"
	statementBlock ->
		  LCURLY statements RCURLY
<## statementBlock -> LCURLY statements RCURLY
symbolTable.blockEnter()
nodes[2].tree = ()
nodes[2].execute()
nodes[0].tree = ('block',) + nodes[2].tree
symbolTable.blockExit()
#>
		;

	"Una sentencia simple"
	simpleStatement ->
		  SUPER LPAREN argExprList RPAREN
<## simpleStatement -> SUPER LPAREN argExprList RPAREN
if not parsingConstructors:
	raise 'La construccin "super(args);"' \
		+ 'slo se puede usar en constructores'
if not firstStatement:
	raise 'La construccin "super(args);" debe ser' \
		+ ' la primera sentencia del constructor'

nodes[3].execute()

parent = symbolTable.getCurrentClass().getParent()
constructor = parent.getConstructor(nodes[3].types)

nodes[0].tree = ('invokespecial', ('this',), constructor, nodes[3].args)
nodes[0].type = constructor.getReturnType() # Obligatoriamente ser <void>
nodes[0].lvalue = False

global hasSuperStatement
hasSuperStatement = True
#>
		| RETURN optimizedExpressions
<## simpleStatement -> RETURN optimizedExpressions
nodes[2].execute()

klass = nodes[2].type
if not klass.isA(currentReturnType):
	raise ('El tipo del return (%s) no es el del mtodo (%s)'\
		+ ' ni un tipo derivado') \
		% (klass, currentReturnType)

nodes[0].tree = ('return', nodes[2].tree)
#>
		| RETURN
<## simpleStatement -> RETURN
if getClass('<void>') != currentReturnType:
	raise 'El mtodo necesita que se devuelva un valor'
nodes[0].tree = ('voidreturn',)
#>
		| IDENT IDENT ASSIGN assignExpr moreVarDecls
<## simpleStatement -> IDENT IDENT ASSIGN assignExpr moreVarDecls
klassName = nodes[1].text
klass = getClass(klassName)

nodes[4].execute()
rtype = nodes[4].type
if not rtype.isA(klass):
	raise 'No se puede asignar un %s a un %s' % (rtype, klass)

nodes[5].tree = ((nodes[2].text, nodes[4].tree),)
nodes[5].type = klass
nodes[5].execute()

for (name, init) in nodes[5].tree:
	symbolTable.setVar(name, klass)

nodes[0].tree = ('decl', klass) + nodes[5].tree
#>
		| IDENT IDENT moreVarDecls
<## simpleStatement -> IDENT IDENT moreVarDecls
klassName = nodes[1].text
klass = getClass(klassName)

nodes[3].tree = ((nodes[2].text, ('null',)),)
nodes[3].type = klass
nodes[3].execute()

for (name, init) in nodes[3].tree:
	symbolTable.setVar(name, klass)

nodes[0].tree = ('decl', klass) + nodes[3].tree
#>
		| optimizedExpressions
<## simpleStatement -> optimizedExpressions
nodes[1].execute()
nodes[0].tree = nodes[1].tree
#>
		|
		;

	"Ms declaraciones de variables"
	moreVarDecls -> COMMA IDENT ASSIGN assignExpr moreVarDecls
<#
klass = nodes[0].type

nodes[4].execute()
rtype = nodes[4].type
if not rtype.isA(klass):
	raise 'No se puede asignar un %s a un %s' % (rtype, klass)

nodes[5].tree = ((nodes[2].text, nodes[4].tree),)
nodes[5].type = klass
nodes[5].execute()

nodes[0].tree += nodes[5].tree
#>
		| COMMA IDENT moreVarDecls
<#
nodes[3].tree = ((nodes[2].text, ('null',)),)
nodes[3].type = nodes[0].type
nodes[3].execute()
nodes[0].tree += nodes[3].tree
#>
		|
		;

	"Expresiones separadas por comas, pudiendo optimizar"
	optimizedExpressions ->
		  expressions
<## optimizedExpressions -> expressions
nodes[1].execute()

if len(nodes[1].tree) > 1:
	nodes[0].tree = ('exprs',) + nodes[1].tree
else:
	nodes[0].tree = nodes[1].tree[0]
nodes[0].lvalue = nodes[1].lvalue
nodes[0].type = nodes[1].types[-1]
#>
		;

	"Expresiones separadas por comas"
	expressions ->
		  assignExpr moreExpressions
<#
nodes[1].execute()

nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = (nodes[1].tree,) + nodes[2].tree
nodes[0].types = (nodes[1].type,) + nodes[2].types
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms expresiones separadas por comas"
	moreExpressions ->
		  COMMA assignExpr moreExpressions
<#
nodes[2].execute()

nodes[3].lvalue = nodes[2].lvalue
nodes[3].execute()

nodes[0].tree = (nodes[2].tree,) + nodes[3].tree
nodes[0].types = (nodes[2].type,) + nodes[3].types
nodes[0].lvalue = nodes[3].lvalue
#>
		|
<#
nodes[0].tree = ()
nodes[0].types = ()
#>
		;

	"Una expresin de asignacin"
	assignExpr ->
		  conditionalExpr moreAssignExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Lado derecho de una asignacin"
	moreAssignExpr ->
		  ASSIGN assignExpr
<#
if not nodes[0].lvalue:
	raise 'No se puede asignar nada a algo que no sea un lvalue'

nodes[2].execute()

leftType = nodes[0].type
rightType = nodes[2].type
if not rightType.isA(leftType):
	raise 'No se puede asignar un %s a un %s' % (rightType, leftType)

nodes[0].tree = ('assign', nodes[0].tree, nodes[2].tree)
nodes[0].type = nodes[2].type
#nodes[0].lvalue = True # No hace falta, ya comprobamos que era cierto
#>
		|
		;

	"Expresin condicional"
	conditionalExpr ->
		  logicalOrExpr moreConditionalExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"La segunda parte de la expr. condicional (el operador ternario)"
	moreConditionalExpr ->
		  QUESTION assignExpr COLON conditionalExpr
<#
nodes[2].execute()
nodes[4].execute()
nodes[0].tree = ('if', nodes[0].tree, nodes[2].tree, nodes[4].tree)
nodes[0].lvalue = False

left = nodes[2].type
right = nodes[4].type

# Devolvemos como tipo de la expresin el ms genrico
if left.isA(right):
	nodes[0].type = right
elif right.isA(left):
	nodes[0].type = left
else:
	raise 'Los tipos de las expresiones then-else del operador ternario' \
		' no son compatibles'
#>
		|
		;

	"OR lgico"
	logicalOrExpr ->
		  logicalAndExpr moreLogicalOrExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms ORs lgicos"
	moreLogicalOrExpr ->
		  LOR logicalAndExpr
<#
nodes[2].execute()

nodes[0].tree = ('lor', nodes[0].tree, nodes[2].tree)
#>
		|
		;

	"AND lgico"
	logicalAndExpr ->
		  equalityExpr moreLogicalAndExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms ANDs lgicos"
	moreLogicalAndExpr ->
		  LAND equalityExpr
<#
nodes[2].execute()

nodes[0].tree = ('land', nodes[0].tree, nodes[2].tree)
#>
		|
		;

	"Igualdad"
	equalityExpr ->
		  relationalExpr moreEqualityExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms igualdades"
	moreEqualityExpr ->
		  EQUAL relationalExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator==', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| NOTEQUAL relationalExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator!=', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| IS relationalExpr
<#
nodes[2].execute()

nodes[0].tree = ('is', nodes[0].tree, nodes[2].tree)
#>
		|
		;

	"Relacin"
	relationalExpr ->
		  additiveExpr moreRelationalExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms relaciones"
	moreRelationalExpr ->
		  LT additiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator<', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| LTE additiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator<=', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| GT additiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator>', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| GTE additiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator>=', [nodes[2].tree], [nodes[2].type])

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		|
		;

	"Suma"
	additiveExpr ->
		  multExpr moreAdditiveExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms sumas"
	moreAdditiveExpr ->
		  PLUS multExpr moreAdditiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator+', [nodes[2].tree], [nodes[2].type])

nodes[3].tree = tree
nodes[3].type = klass
nodes[3].lvalue = False
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| MINUS multExpr moreAdditiveExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator-', [nodes[2].tree], [nodes[2].type])

nodes[3].tree = tree
nodes[3].type = klass
nodes[3].lvalue = False
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		|
		;

	"Multiplicacin"
	multExpr ->
		  unaryExpr moreMultExpr
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Ms multiplicaciones"
	moreMultExpr ->
		  MUL unaryExpr moreMultExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator*', [nodes[2].tree], [nodes[2].type])

nodes[3].tree = tree
nodes[3].type = klass
nodes[3].lvalue = False
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| DIV unaryExpr moreMultExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator/', [nodes[2].tree], [nodes[2].type])

nodes[3].tree = tree
nodes[3].type = klass
nodes[3].lvalue = False
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| MOD unaryExpr moreMultExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator%', [nodes[2].tree], [nodes[2].type])

nodes[3].tree = tree
nodes[3].type = klass
nodes[3].lvalue = False
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		|
		;

	"Expresin unaria"
	unaryExpr ->
		  LPAREN IDENT RPAREN unaryExpr
<#
klassName = nodes[2].text
klass = getClass(klassName)

nodes[4].execute()

exprType = nodes[4].type
if exprType.isA(klass):
	# Es un upcast, no hacen falta comprobaciones adicionales
	nodes[0].tree = nodes[4].tree
elif klass.isA(exprType):
	# Es un downcast, slo se puede resolver en ejecucin
	nodes[0].tree = ('downcast', klass, nodes[4].tree)
else:
	raise 'Los tipos del cast y de la expresin no estn relacionados'

nodes[0].type = klass
nodes[0].lvalue = nodes[4].lvalue
#>
		| PLUS postfixExpr
<#
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = False
#>
		| MINUS postfixExpr
<#
nodes[2].execute()

nodes[0].tree = ('neg', nodes[1].tree)
nodes[0].type = nodes[2].type
nodes[0].lvalue = False
#>
		| LNOT postfixExpr
<#
nodes[2].execute()

nodes[0].tree = ('lnot', nodes[2].tree)
nodes[0].type = getClass('Bool')
nodes[0].lvalue = False
#>
		| INC unaryExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[2].tree, nodes[2].type,
	'operator++', [], [])
nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = nodes[2].lvalue
#>
		| DEC unaryExpr
<#
nodes[2].execute()

tree, klass = generate_invokeVirtual(nodes[2].tree, nodes[2].type,
	'operator--', [], [])
nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = nodes[2].lvalue
#>
		| postfixExpr
<#
nodes[1].execute()

nodes[0].tree = nodes[1].tree
nodes[0].type = nodes[1].type
nodes[0].lvalue = nodes[1].lvalue
#>
		;

	"Ms expresiones unarias"
	postfixExpr ->
		  primaryExpr postfixSuffixes
<#
nodes[1].execute()

nodes[2].tree = nodes[1].tree
nodes[2].type = nodes[1].type
nodes[2].lvalue = nodes[1].lvalue
nodes[2].execute()

nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Sufijos"
	postfixSuffixes ->
		  DOT IDENT LPAREN argExprList RPAREN postfixSuffixes
<#
nodes[4].execute()

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	nodes[2].text, nodes[4].args, nodes[4].types)

nodes[6].tree = tree
nodes[6].type = klass
nodes[6].lvalue = False
nodes[6].execute()

nodes[0].tree = nodes[6].tree
nodes[0].type = nodes[6].type
nodes[0].lvalue = nodes[6].lvalue
#>
		| DOT IDENT postfixSuffixes
<#
leftType = nodes[0].type
name = nodes[2].text
field = leftType.getField(name) # Para causar un error si el campo no existe

nodes[3].tree = ('field', nodes[0].tree, nodes[0].type, nodes[2].text)
nodes[3].type = field.getClass()
nodes[3].lvalue = True
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| INC
<#
if not nodes[0].lvalue:
	raise 'El operando del operador de postincremento debe ser un lvalue'

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator++', [('int', 0)], [getClass('Integer')])
nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| DEC
<#
if not nodes[0].lvalue:
	raise 'El operando del operador de postincremento debe ser un lvalue'

tree, klass = generate_invokeVirtual(nodes[0].tree, nodes[0].type,
	'operator--', [('int', 0)], [getClass('Integer')])
nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False
#>
		|
		;

	"Argumentos de la llamada a un mtodo"
	argExprList ->
		  expressions
<#
nodes[1].execute()
nodes[0].args = nodes[1].tree
nodes[0].types = nodes[1].types
#>
		|
<#
nodes[0].args = ()
nodes[0].types = ()
#>
		;

	"Expresin primaria"
	primaryExpr ->
		  NEW IDENT LPAREN argExprList RPAREN
<#
nodes[4].execute()
klass = getClass(nodes[2].text)
ctor = klass.getConstructor(nodes[4].types)
nodes[0].tree = ('new', klass, ctor, nodes[4].args)
nodes[0].type = klass
nodes[0].lvalue = False
#>
		| NULL
<#
nodes[0].tree = ('null',)
nodes[0].type = getClass('<null>')
nodes[0].lvalue = False
#>
		| THIS
<#
nodes[0].tree = ('this',)
nodes[0].type = symbolTable.getCurrentClass()
nodes[0].lvalue = False
#>
		| TRUE
<#
nodes[0].tree = ('true',)
nodes[0].type = getClass('Bool')
nodes[0].lvalue = False
#>
		| SUPER DOT superAccess
<#
parent = symbolTable.getCurrentClass().getParent()
if not parent:
	raise 'Esta clase no tiene clases base'
nodes[3].type = parent
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| IDENT LPAREN argExprList RPAREN
<#
nodes[3].execute()

tree, klass = generate_invokeVirtual(('this',), symbolTable.getCurrentClass(),
	nodes[1].text, nodes[3].args, nodes[3].types)

nodes[0].tree = tree
nodes[0].type = klass
nodes[0].lvalue = False

#>
		| IDENT
<#
name = nodes[1].text
nodes[0].tree = ('ident', name)
nodes[0].type = symbolTable.getVar(name)
nodes[0].lvalue = True
#>
		| INTEGER
<#
nodes[0].tree = ('int', int(nodes[1].text))
nodes[0].type = getClass('Integer')
nodes[0].lvalue = False
#>
		| STRING
<#
nodes[0].tree = ('str', nodes[1].text[1:-1])
nodes[0].type = getClass('String')
nodes[0].lvalue = False
#>
		| LPAREN optimizedExpressions RPAREN
<#
nodes[2].execute()
nodes[0].tree = nodes[2].tree
nodes[0].type = nodes[2].type
nodes[0].lvalue = nodes[2].lvalue
#>
		;

	"Acceso a un miembro de nuestra clase padre"
	superAccess ->
		  SUPER DOT superAccess
<#
parent = symbolTable.getCurrentClass().getParent()
if not parent:
	raise 'Esta clase no tiene clases base'
nodes[3].type = parent
nodes[3].execute()

nodes[0].tree = nodes[3].tree
nodes[0].type = nodes[3].type
nodes[0].lvalue = nodes[3].lvalue
#>
		| IDENT LPAREN argExprList RPAREN
<#
nodes[3].execute()

method = nodes[0].type.getMethod(nodes[1].text, nodes[3].types)

nodes[0].tree = ('invokespecial', ('this',), method, nodes[3].args)
nodes[0].type = method.getReturnType()
nodes[0].lvalue = False

#>
		| IDENT
<#
leftType = nodes[0].type
name = nodes[2].text
field = leftType.getField(name) # Ya causa l un error si el campo no existe

nodes[0].tree = ('field', nodes[0].tree, nodes[0].type, nodes[2].text)
nodes[0].type = field.getClass()
nodes[0].lvalue = True
#>
		;
}

Skip = {
	" ";
	"\t";
	"\n";
}

NotSkip = {
}
