Language    = Simple

Scanner = {
	"Digit Token"
		digit -> "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"
			;
	"Number Token"
		NUMBER -> digit moreDigits
			;
	"Zero or more digits token"
		moreDigits -> digit moreDigits
			|
			;
	"Characacter Token"
		char -> "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" | "j" | "k" | "l" | "m" | "n" | "" |
			  "o" | "p" | "q" | "r" | "s" | "t" | "u" | "w" | "x" | "y" | "z" | "" | "" | "" | "" | "" |
			  "A" | "B" | "C" | "D" | "E" | "F" | "G" | "H" | "I" | "J" | "K" | "L" | "M" | "N" | "" |
			  "O" | "P" | "Q" | "R" | "S" | "T" | "U" | "W" | "X" | "Y" | "Z" | "" | "" | "" | "" | ""
			;
	"Character or Digit Token"
		charOrDigit -> char
				| digit
				| "_"
				;
	"ID Token"
		ID -> char moreCharsOrDigits
			;
	"Zero or more chars or digits token"
		moreCharsOrDigits -> charOrDigit moreCharsOrDigits
			|
			;
	"SEMICOLON Token"
		SEMICOLON -> ";"
			;
	"OPENBRACE Token"
		OPENBRACE -> "("
			;
	"CLOSEBRACE Token"
		CLOSEBRACE -> ")"
			;
	"PLUS Operator token"
		PLUS -> "+"
			;
	"MINUS Operator token"
		MINUS -> "-"
			;
	"TIMES Operator token"
		TIMES -> "*"
			;
	"BY Operator token"
		BY -> "/"
			;
	"ASIGN token"
		ASIGN -> "="
			;
}


Parser = {
	"Initial Free-Context Rule"
		S -> statement moreStatements SEMICOLON <#
# We want "vars" to be used in more actions
global vars
vars={}
nodes[1].execute()
nodes[2].execute()
#>
			;

	"Zero or more Statements"
		moreStatements -> SEMICOLON statement moreStatements <#
nodes[2].execute()
nodes[3].execute()
#>
			|
			;

	"Statement" 
		statement -> _REIFY_ <#
nodes[1].execute()
#>
			| asignment <#
nodes[1].execute()
#>
			| expression <#
nodes[1].execute()
write("Expression value: "+str(nodes[1].value)+".\n")
#>
			;

	"Asignment Statement"
		asignment -> ID ASIGN expression <#
nodes[3].execute()
vars[nodes[1].text]=nodes[3].value
#>
			;

	"Binary Expression"
		expression -> term moreTerms <#
# Every node has its evaluation on the attribute "value"
# Its initival value is saved on the attribute "init"
nodes[1].execute()
nodes[2].init=nodes[1].value
nodes[2].execute()
nodes[0].value=nodes[2].value
#>
			;

	"Zero or More Terms"
		moreTerms -> PLUS term moreTerms <#
nodes[2].execute()
nodes[3].init=nodes[0].init+nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| MINUS term moreTerms  <#
nodes[2].execute()
nodes[3].init=nodes[0].init-nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| <#
nodes[0].value=nodes[0].init
#>
			;

	"Binary Expression Term"
		term -> factor moreFactors <#
nodes[1].execute()
nodes[2].init=nodes[1].value
nodes[2].execute()
nodes[0].value=nodes[2].value
#>
			;

	"Zero or More Factors"
		moreFactors -> TIMES factor moreFactors <#
nodes[2].execute()
nodes[3].init=nodes[0].init*nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| BY factor moreFactors <#
nodes[2].execute()
nodes[3].init=nodes[0].init/nodes[2].value
nodes[3].execute()
nodes[0].value=nodes[3].value
#>
			| <#
nodes[0].value=nodes[0].init
#>
			;

	"Binary Expression Factor"
		factor -> ID <#
nodes[0].value=vars[nodes[1].text]
#>
			| NUMBER <#
nodes[0].value=int(nodes[1].text)
#>

			| OPENBRACE expression CLOSEBRACE <#
nodes[2].execute()
nodes[0].value=nodes[2].value
#>

			;
}


Skip={  "\t";  "\n"; " ";}

NotSkip = {  }
