Language = VerySimple
Scanner = {
	"Digit Token"
		digit -> "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9" ;
	"Number Token"
		NUMBER -> digit moreDigits ;
	"Zero or more digits token"
		moreDigits -> digit moreDigits
			|	;
	"Characacter Token"
		char -> "a" | "b" | "c" | "d" | "e" | "f" | "g" | "h" | "i" | "j" | "k" | "l" |
			  "m" | "n" "o" | "p" | "q" | "r" | "s" | "t" | "u" | "w" | "x" | "y" | "z" ;
	"Character or Digit Token"
		charOrDigit -> char | digit ;
	"ID Token"
		ID -> char moreCharsOrDigits	;
	"Zero or more chars or digits token"
		moreCharsOrDigits -> charOrDigit moreCharsOrDigits
			| ;
	"SEMICOLON Token"
		SEMICOLON -> ";"	;
	"ASSIGN token"
		ASSIGN -> "=" ;
}
Parser = {
	"Initial Context-Free Rule"
		S -> statement moreStatements SEMICOLON <#
global vars
vars={}
nodes[1].execute()
nodes[2].execute()
#>	;
	"Zero or more Statements"
		moreStatements -> SEMICOLON statement moreStatements <#
nodes[2].execute()
nodes[3].execute()
#>
			| ;
	"Statement" 
		statement -> _REIFY_ <#
nodes[1].execute()
#>
			| assignment <#
nodes[1].execute()
#>
			| expression <#
nodes[1].execute()
write("Expression value: "+str(nodes[1].value)+".\n")
#> ;
	"Assignment Statement"
		assignment -> ID ASSIGN expression <#
nodes[3].execute()
vars[nodes[1].text]=nodes[3].value
#> ;
	"Binary Expression Factor"
		expression -> ID <#
nodes[0].value=vars[nodes[1].text]
#>
			| NUMBER <#
nodes[0].value=int(nodes[1].text)
#> ;
}
Skip={  "\t";  "\n"; " ";}
NotSkip = {  }
